package com.madeu.controller.mobile.mobilehome;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobileevent.MobileEventService;
import com.madeu.service.mobile.mobilemedical.MobileMedicalService;
import com.madeu.service.web.webhome.WebHomeService;
import com.madeu.service.web.webmenu.WebMenuService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller
public class MobileHomeController extends ManagerDraftAction{

	@Autowired
	private WebHomeService webHomeService;
	@Autowired
	private MobileMedicalService mobileMedicalService;
	@Autowired
	private MobileEventService mobileEventService;
	@Autowired
	private WebMenuService webMenuService;

	/**
	 *
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilehome/homeIntro.do")
	public String homeIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobileHomeController homeIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("MobileHomeController homeIntro END");
		return "/mobile/home/home";
	}

	/**
	 * mobile 홈 이동
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilehome/mobileIntro.do")
	public String mobileIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobileHomeController mobileIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("MobileHomeController mobileIntro END");
		return "/mobile/mobileIntro/mobileIntro";
	}

	/**
	 * 메인노출 이벤트 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilehome/selectListEvent.do")
	public ModelAndView selectListEvent(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileHomeController selectListEvent START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileEventService.selectListEvent(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileHomeController selectListEvent END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 메인노출 시술보드 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilehome/selectListMedicalBoard.do")
	public ModelAndView selectListCompany(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileHomeController selectListMedicalBoard START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMedicalService.selectListMedicalBoard(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileHomeController selectListMedicalBoard END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

}